#include "extractor.h"
int main(int argc, char** argv)
{
	
	Extractor app;
	
		CharRenderer r;
		r.SetSize(22);
		struct item 
		{
			int i;
			const char* s;
		}; 
		//GreekLetters
		
		//UpperCase
		r.SetPath("/boot/home/config/teTeX/share/texmf/fonts/type1/bluesky/cm/cmr8.pfb");	
		
		item greek_items[] = {
		{128,"Gamma"},
		{1,"Delta"},
		{2,"Theta"},
		{3,"Lambda"},
		{4,"Xi"},
		{5,"Pi"},
		{6,"Sigma"},
		{7,"Upsilon"},
		{8,"Phi"},
		{9,"Psi"},
		{10,"Omega"},
		{11,"alpha"},
		{12,"beta"},
		{13,"gamma"},
		{14,"delta"},
		{15,"epsilon"},
		{16,"zeta"},
		{17,"eta"},
		{18,"theta"},
		{19,"iota"},
		{20,"kappa"},
		{21,"lambda"},
		{22,"mu"},
		{23,"nu"},
		{24,"xi"},
		{25,"pi"},
		{26,"rho"},
		{27,"sigma"},
		{28,"tau"},
		{29,"upsilon"},
		{30,"phi"},
		{31,"chi"},
		{32,"psi"},
		{33,"omega"},
		{34,"varepsilon"},
		{35,"vartheta"},
		{36,"varpi"},
		{37,"varrho"},
		{38,"varsigma"},
		{39,"varphi"}
		};
		
		BBitmap* glyph;
		unsigned char* p;
		int32 size;
		char buf[5];
		ofstream outfile("greek.h");
		outfile << "#ifndef GREEK_H_" << endl;
		outfile << "#define GREEK_H_" << endl;
		BString about;
		BString item_array;
		int total_items=40;
		item_array << "const sextet greek_data[] = {\n";
		//bool SwitchedFontToLower=false;
		for(int i=0;i<total_items;i++)
		{
			if(i == 11)	//switch over to the lower case ones
				r.SetPath("/boot/home/config/teTeX/share/texmf/fonts/type1/bluesky/cm/cmmi8.pfb");
				
			glyph = r.Render(greek_items[i].i);
			BRect gb = glyph->Bounds();
			size = glyph->BitsLength();
			about << "//bitmap_" << greek_items[i].s << "[" << size << "] : w = " << (float)gb.Width() << " , h = " << (float)gb.Height() << "\n";
			if(i != total_items-1)
				item_array << "{\"" << greek_items[i].s << "\"," << size << "," << (float)gb.Width() << "," << (float)gb.Height()<< ",bitmap_" << greek_items[i].s <<",\"\\\\" << greek_items[i].s << "\"},\n";
			else
				item_array << "{\"" << greek_items[i].s << "\"," << size << "," << (float)gb.Width() << "," << (float)gb.Height() <<",bitmap_" << greek_items[i].s << ",\"\\\\" << greek_items[i].s << "\"}\n";
			
			p = (unsigned char*)glyph->Bits();
			
			outfile << "const unsigned char bitmap_" << greek_items[i].s << "[" << size << "] = {\n";
			int count = 0;
			
			
			for(int i=0;i<size;i++)
			{
				if(i == size -1)
				{	
					sprintf(buf,"%u};",p[i]);
					outfile << buf;
				}else
				{	
					sprintf(buf,"%u",p[i]);
					outfile << buf << ",";
				}
				if(count == 20)
				{	
					outfile << endl;
					count = 0;	
				}
				else
					count++;
			}
			outfile << endl;
		}
		item_array << "};\n";
		outfile << "struct sextet\n{\n\tconst char* s;\n\tint n;\n\tfloat w;\n\tfloat h;\n\tconst unsigned char* p;\n\tconst char* cmd;\n};\n";
		outfile << about.String() << endl;
		outfile << "const int greek_items = " << (int)total_items << ";" << endl;
		outfile << item_array.String() << endl;
		
		outfile << "#endif" << endl;
		outfile.close();
		
	
	return 0;
}

Extractor::Extractor() : BApplication("application/x-vnd.misza-Extractor")
{
	
}
Extractor::~Extractor()
{
	//empty
}
