#include "SearchWindow.h"
/*void scrollView::MakeFocus(bool all=true)
{
	Target()->MakeFocus();

}
*/
SearchWindow::SearchWindow(BRect r,BMessenger* messenger,Prefs* p) : BWindow(r,"Search Dialog",B_FLOATING_WINDOW,B_NOT_ZOOMABLE|B_NOT_RESIZABLE)
{
	SetFeel(B_NORMAL_WINDOW_FEEL);
	prefs = p;
	parent = new parentView(Bounds());//,"parent",B_FOLLOW_ALL_SIDES,B_WILL_DRAW);
	parent->SetViewColor(ui_color(B_PANEL_BACKGROUND_COLOR));
	AddChild(parent);
	
	msgr = messenger;
	
	const int TexViewWidth=200;
	const int TexViewHeight=80;
	const int StrViewHeight=20;
	const int StrViewWidth=80;
	const int ButtonWidth=100;
	const int ButtonHeight=20;
	r = Bounds();
	
	r.left=6;
	r.right = r.left+StrViewWidth;
	r.top = 10;
	r.bottom = r.top+StrViewHeight;
	BFont font(be_bold_font);
	font.SetSize(12);
	
/*	fvlabel = new zStringView(r,"fvlabel","Find:");
	fvlabel->SetFont(&font);
	
	parent->AddChild(fvlabel);
*/	
	r.OffsetBy(0,StrViewHeight+5);
	
	r.left=10;
	r.right = r.left+TexViewWidth-B_V_SCROLL_BAR_WIDTH;
	//r.top = 10;
	r.bottom = r.top+TexViewHeight;
	font = be_fixed_font;
	font.SetSize(12);
	BRect fvRect(r);
	BRect fvTextRect;//(fvRect);
	fvTextRect.top=0;
	fvTextRect.left=0;
	fvTextRect.right=fvRect.Width();
	fvTextRect.bottom=fvRect.Height();
	
	
	fvTextRect.InsetBy(5,5);
	
	findview = new TexView(fvRect,fvTextRect,prefs);
	//findview->MakeFocus(true);
	findview->SetNormalFocus();
	findview->SetAttachedFocus();
	//findview->SetFlags(B_NAVIGABLE|replaceview->Flags());
	scrollView* sv = new scrollView("ScrollView",findview,B_FOLLOW_LEFT | B_FOLLOW_TOP,
	B_WILL_DRAW|B_FRAME_EVENTS|B_NAVIGABLE,false,true,B_FANCY_BORDER);
	sv->SetViewColor(ui_color(B_PANEL_BACKGROUND_COLOR));
	parent->AddChild(sv);
	
	r.OffsetBy(0,TexViewHeight+5);
	
	r.left=6;
	r.right = r.left+StrViewWidth;
	//r.top = 10;
	r.bottom = r.top+StrViewHeight;
	
/*	rvlabel = new zStringView(r,"rvlabel","Replace:");
	font = be_bold_font;
	font.SetSize(12);
	rvlabel->SetFont(&font);
	
	parent->AddChild(rvlabel);
*/
	r.OffsetBy(0,StrViewHeight+5);
	
	r.left=10;
	r.right = r.left+TexViewWidth-B_V_SCROLL_BAR_WIDTH;
	//r.top = 10;
	r.bottom = r.top+TexViewHeight;
	font = be_fixed_font;
	font.SetSize(12);
	BRect rvRect(r);
	BRect rvTextRect;//(fvRect);
	rvTextRect.top=0;
	rvTextRect.left=0;
	rvTextRect.right=rvRect.Width();
	rvTextRect.bottom=rvRect.Height();
	
	
	rvTextRect.InsetBy(5,5);
	
	replaceview = new TexView(rvRect,rvTextRect,prefs);
	replaceview->SetNormalFocus();
	//replaceview->SetFlags(B_NAVIGABLE|replaceview->Flags());
	scrollView* sv2 = new scrollView("ScrollView",replaceview,B_FOLLOW_LEFT | B_FOLLOW_TOP,
	B_WILL_DRAW|B_FRAME_EVENTS|B_NAVIGABLE,false,true,B_FANCY_BORDER);
	sv2->SetViewColor(ui_color(B_PANEL_BACKGROUND_COLOR));
	parent->AddChild(sv2);
	
	BRect ButtonRect(Bounds());
	ButtonRect.left=fvTextRect.right+50;
	ButtonRect.top=36;//fvTextRect.top;
	ButtonRect.right=ButtonRect.left+ButtonWidth;
	ButtonRect.bottom=ButtonRect.top+ButtonHeight;
	
	find = new BButton(ButtonRect,"find","Find",new BMessage(SEARCH_WINDOW_FIND));
	parent->AddChild(find);
	find->MakeDefault(true);
	ButtonRect.OffsetBy(0,ButtonHeight+10);
	
	replace = new BButton(ButtonRect,"replace","Replace",new BMessage(SEARCH_WINDOW_REPLACE));
	parent->AddChild(replace);
	ButtonRect.OffsetBy(0,ButtonHeight+10);

	replaceall = new BButton(ButtonRect,"replaceall","Replace All",new BMessage(SEARCH_WINDOW_REPLACE_ALL));
	parent->AddChild(replaceall);
	ButtonRect.OffsetBy(0,ButtonHeight+10);
	
	ButtonRect.right += 30;
	cbCaseSensitive = new BCheckBox(ButtonRect,"cdCaseSensitive","Case Sensitive",new BMessage(SEARCH_WINDOW_SETTINGS_CHANGED));
	parent->AddChild(cbCaseSensitive);
	cbCaseSensitive->SetValue(prefs->IsCaseSensitive);
	ButtonRect.OffsetBy(0,ButtonHeight+10);
	
	cbWrapAround = new BCheckBox(ButtonRect,"cbWrapAround","Wrap Around",new BMessage(SEARCH_WINDOW_SETTINGS_CHANGED));
	parent->AddChild(cbWrapAround);
	cbWrapAround->SetValue(prefs->IsWrapAround);
	ButtonRect.OffsetBy(0,ButtonHeight+10);
	
	cbSearchBackwards = new BCheckBox(ButtonRect,"cbSearchBackwards","Search Backwards",new BMessage(SEARCH_WINDOW_SETTINGS_CHANGED));
	parent->AddChild(cbSearchBackwards);
	cbSearchBackwards->SetValue(prefs->IsSearchBackwards);
	ButtonRect.OffsetBy(0,ButtonHeight+10);
	
	cbAllDocs = new BCheckBox(ButtonRect,"cbAllDocs","Replace In All",new BMessage(SEARCH_WINDOW_SETTINGS_CHANGED));
	parent->AddChild(cbAllDocs);
	cbAllDocs->SetValue(prefs->IsAllDocs);
	ButtonRect.OffsetBy(0,ButtonHeight+10);
	
	//ButtonRect.OffsetBy(0,ButtonHeight+10);
	
}
SearchWindow::~SearchWindow()
{
	delete msgr;
}
void SearchWindow::MessageReceived(BMessage* msg)
{
	switch(msg->what)
	{
		case SEARCH_WINDOW_SETTINGS_CHANGED:
		{
			prefs->IsAllDocs = (cbAllDocs->Value());// == B_CONTROL_ON);
			prefs->IsSearchBackwards = (cbSearchBackwards->Value());// == B_CONTROL_ON);
			prefs->IsWrapAround = (cbWrapAround->Value());// == B_CONTROL_ON);
			prefs->IsCaseSensitive = (cbCaseSensitive->Value());// == B_CONTROL_ON);
			prefs->Save();
		}break;
		case SEARCH_WINDOW_FIND:
		{
			BMessage* fmsg = new BMessage(SEARCH_WINDOW_FIND);
			if(findview->TextLength() > 0 
			&& fmsg->AddString("ftext",findview->Text()) == B_OK)
			{
				msgr->SendMessage(fmsg);
			}
		
		}break;
		case SEARCH_WINDOW_REPLACE:	
		{
			BMessage* rmsg = new BMessage(SEARCH_WINDOW_REPLACE);
			if(findview->TextLength() > 0 //&& replaceview->TextLength() > 0
			&& rmsg->AddString("ftext",findview->Text()) == B_OK
			&& rmsg->AddString("rtext",replaceview->Text()) == B_OK			
			&& rmsg->AddBool("all",false)==B_OK)
			{
				msgr->SendMessage(rmsg);
			}
		}break;
		case SEARCH_WINDOW_REPLACE_ALL:
		{
			BMessage* rmsg = new BMessage(SEARCH_WINDOW_REPLACE_ALL);
			if(findview->TextLength() > 0 //&& replaceview->TextLength() > 0
			&& rmsg->AddString("ftext",findview->Text()) == B_OK
			&& rmsg->AddString("rtext",replaceview->Text()) == B_OK			
			&& rmsg->AddBool("all",true)==B_OK)
			{
				/*cout << "Replace:" << endl;
				cout << findview->Text() << endl;
				cout << "With:" << endl;
				cout << replaceview->Text() << endl;
				*/
				msgr->SendMessage(rmsg);
			}
		}break;
		default:
			BWindow::MessageReceived(msg);
	}
}
void SearchWindow::Quit()
{
	msgr->SendMessage(new BMessage(SEARCH_WINDOW_QUIT));
	BWindow::Quit();
}

