#ifndef _TEX_VIEW_H_
#define _TEX_VIEW_H_

#include <TextView.h>
#include <View.h>
#include <Font.h>
#include <String.h>	
#include <vector>
#include <Region.h>
#include <iostream>
#include <string>
#include <stdio.h>
#include <Window.h>
#include <Message.h>
#include <Messenger.h>
#include <algorithm>
#include <cctype>
#include <stack.h>
#include <ScrollView.h>
#include <stdlib.h>
#include "Constants.h"
#include <cassert>
#include "Prefs.h"
#include <Entry.h>
#include <Roster.h>
#include <cassert>

class TexView : public BTextView
{
	public:
		TexView(BRect r,BRect textRect,Prefs* p);
		virtual void AttachedToWindow();
		virtual void KeyDown(const char* bytes, int32 numBytes);
		void SetText(const char* text,int32 length,const text_run_array* runs = NULL);
		void SetText(BFile* file,int32 offset,int32 length,const text_run_array* runs = NULL);
		virtual void MessageReceived(BMessage* msg);
		bool Contains(vector<BString>& v,BString s);
		bool IsBrace(char c);
		virtual void FrameResized(float w,float h);
		virtual bool CanEndLine(int32 offset);
		
		void ShiftLeft();
		void ShiftRight();
		
		
		virtual void MouseMoved(BPoint point,uint32 transit,const BMessage* msg);
		virtual void MouseDown(BPoint point);
		virtual void MouseUp(BPoint point);
		virtual void Draw(BRect r);
		
		//void SetFontAndColor(int32 start,int32 finish,const BFont* font,uint32 properties=B_FONT_ALL,const vector<rgb_color>& color=NULL);
		virtual void Select(int32 start,int32 finish);
		void SetNormalFocus();
		void SetAttachedFocus();
		int32 OffsetAtIndex(int32 index);// const;
		int32 OffsetAt(BPoint point);
		int32 LineAt(int32 offset);// const;	
		void FillSolEol(vector<int>& s,vector<int>& e,int start,int finish);	

		void TwoColorPlateau(char c,int sol,int eol,rgb_color c1,vector<rgb_color>& colorVec);/*,vector<BFont>& fontVec*/
		//,int displaced);vector<rgb_color>&
	
		int IsMathMode(int offset,/*int sol,int eol*/vector<BString>& v,bool IsStart/*,bool& IsMultiLine*/);
		void SetMathModes(vector<rgb_color>& colorVec);//,vector<BFont>& fontVec);
	
		//void ParseLine(int sol,int eol,vector<rgb_color>& colorVec);
		void ParseLine(int sol,int eol,vector<rgb_color>& colorVec);
		void IParseLine(int sol,int eol);
		void ITwoColorPlateau(char c,int sol,int eol,rgb_color c1,vector<rgb_color>& colorVec);/*,vector<BFont>& fontVec*/

		void ParseAll(int start,int finish,bool IsInteractive);
		void LoadFile(entry_ref *ref);
		int32 GetMathSol(int sol);
		int FindFirstOnLine(char c,int offset,int eol);
//		void FillLines(vector<int> sols,vector<int> eols,int lo,int hi,const char* text,int32 text_length);
		//int FindFirstUrlOnLine(int offset,int eol);
		//int FindLastUrlPos(int h,int eol);
		void GoToLine(int32 index);
		int32 CountLines();
		void UpdateColors();
		void UpdateFontSize();
		//BString FindUrl(int32 offset);
		//bool IsBadUrlChar(int32 h);
		//bool IsUrlCommented(int32 start,int32 finish);
		int32 CountPhysicalLines();
	private:
		//vector<undo_type> UndoStack;
		//vector<undo_type> RedoStack;
		
		bool IsShifting;
		bool IsColSel;
		BPoint ColStart;
		BPoint ColFinish;

		BString fCache;
		BString fText;
		vector <BString> green_matches;
		vector <BString> purple_matches;
		bool IsNormalFocus;
		bool HasAttachedFocus;
		BFont f;
		Prefs* prefs;
		//const char* text;
	protected:
		virtual void InsertText(const char* text,int32 length,int32 offset,const text_run_array* runner);
		virtual void DeleteText(int32 start, int32 finish);
		
};
#endif
		//bool IsLineCommented(int32 line);
		//void GoToLine(int32 index);
		//int32 CurrentLine() const;
		//int32 CountLines() const;
		//int32 CountPhysicalLines() const;
		//int32 OffsetAt(int32 index) const;
		//int32 LineAt(int32 offset) const;
		//void GetSolEol(int32 line,int32& sol,int32& eol);
		//virtual void Draw(BRect r);
		///BString GetText(int32 start,int32 finish);
		//void Undo();
		//void Redo();
		//void PushUndo(bool val) { IsUndo = val;}
		//void GoToLine(int32 index);
		//bool CanUndo();
		//bool CanRedo();
		//void BalanceBrackets();
		//stack<utype> UndoStack;
		//stack<utype> RedoStack;
		//bool IsUndo;
		//bool IsRedo;
