#include "misza_status_view.h"

#include <iostream>
zStatusView::zStatusView(BRect r) //
: zView(r,"zStatusView",B_FOLLOW_BOTTOM,B_WILL_DRAW)
{
	theText = "";
	SetViewColor(zBeGreyPanel);
}

void zStatusView::SetText(const char* text)
{
	theText = text;
	if(Window())
		Render();
}

void zStatusView::Render()
{
	bitmap->Lock();
		
		BRect r = bView->Bounds();
		BFont font(be_fixed_font);
		font.SetSize(12);
		bView->SetFont(&font);
		//BRect w = Window()->Bounds();
		//r.right = w.right;
		//bView->ResizeTo(r.right-r.left,r.bottom-r.top);
		//bitmap->ResizeTo(r.right-r.left,r.bottom-r.top);
		//r.PrintToStream();
		bView->SetHighColor(ViewColor());
		bView->FillRect(Bounds());
		
		bView->SetHighColor(zWhite);
		bView->StrokeLine(r.LeftTop(),r.RightTop());
		bView->StrokeLine(r.LeftTop(),r.LeftBottom());
		
		bView->SetHighColor(tint_color(ViewColor(),B_DARKEN_1_TINT));
		bView->StrokeLine(r.RightBottom(),BPoint(r.right,r.top+1));
		bView->StrokeLine(r.RightBottom(),BPoint(r.left+1,r.bottom));
		
		if(theText.Length() != 0)
		{
			bView->SetHighColor(zBlack);
			bView->SetLowColor(ViewColor());
			bView->MovePenTo(3,r.bottom-3);
			bView->DrawString(theText.String());
		}
	bView->Sync();
	DrawBitmapAsync(bitmap,Bounds(),Bounds());
	Flush();
	Sync();

	bitmap->Unlock();
}

void zStatusView::Draw(BRect drawRect)
{
	Render();	
}

